%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
# ec2,elb failing locally
# rds,iam,route53,s3,autoscaling,aws,exp/mturk,exp/sdb,exp/sns locally ok
%global with_check 0
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define copying() \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7 \
%license %{*} \
%else \
%doc %{*} \
%endif

%global provider        github
%global provider_tld    com
%global project         mitchellh
%global repo            goamz
# https://github.com/mitchellh/goamz
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          caaaea8b30ee15616494ee68abd5d8ebbbef05cf
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0
Release:        0.7.git%{shortcommit}%{?dist}
Summary:        An Amazon Library for Go
License:        LGPLv3+
URL:            http://%{import_path}
Source0:        https://github.com/%{project}/%{repo}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
BuildRequires: golang(github.com/motain/gocheck)
BuildRequires: golang(github.com/vaughan0/go-ini)
%endif

Requires:      golang(github.com/motain/gocheck)
Requires:      golang(github.com/vaughan0/go-ini)

Provides:      golang(%{import_path}/autoscaling) = %{version}-%{release}
Provides:      golang(%{import_path}/aws) = %{version}-%{release}
Provides:      golang(%{import_path}/ec2) = %{version}-%{release}
Provides:      golang(%{import_path}/ec2/ec2test) = %{version}-%{release}
Provides:      golang(%{import_path}/elb) = %{version}-%{release}
Provides:      golang(%{import_path}/exp/mturk) = %{version}-%{release}
Provides:      golang(%{import_path}/exp/sdb) = %{version}-%{release}
Provides:      golang(%{import_path}/exp/sns) = %{version}-%{release}
Provides:      golang(%{import_path}/iam) = %{version}-%{release}
Provides:      golang(%{import_path}/iam/iamtest) = %{version}-%{release}
Provides:      golang(%{import_path}/rds) = %{version}-%{release}
Provides:      golang(%{import_path}/route53) = %{version}-%{release}
Provides:      golang(%{import_path}/s3) = %{version}-%{release}
Provides:      golang(%{import_path}/s3/s3test) = %{version}-%{release}
Provides:      golang(%{import_path}/testutil) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%ifarch 0%{?gccgo_arches}
function gotest { %{gcc_go_test} "$@"; }
%else
%if 0%{?golang_test:1}
function gotest { %{golang_test} "$@"; }
%else
function gotest { go test "$@"; }
%endif
%endif

export GOPATH=%{buildroot}/%{gopath}:%{gopath}
gotest %{import_path}/autoscaling
gotest %{import_path}/aws
gotest %{import_path}/ec2
gotest %{import_path}/elb
gotest %{import_path}/exp/mturk
gotest %{import_path}/exp/sdb
gotest %{import_path}/exp/sns
gotest %{import_path}/iam
gotest %{import_path}/rds
gotest %{import_path}/route53
gotest %{import_path}/s3
%endif

%if 0%{?with_devel}
%files devel -f devel.file-list
%copying LICENSE
%doc CHANGES.md README.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%dir %{gopath}/src/%{import_path}
%endif

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%copying LICENSE
%doc CHANGES.md README.md
%endif

%changelog
* Fri Aug 07 2015 Fridolin Pokorny <fpokorny@redhat.com> - 0-0.7.gitcaaaea8
- Update spec file to spec-2.0
  resolves: #1223451

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.6.gitcaaaea8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed May 20 2015 jchaloup <jchaloup@redhat.com> - 0-0.5.gitcaaaea8
- Bump to upstream caaaea8b30ee15616494ee68abd5d8ebbbef05cf
- Add license macro
- Remove runtime dependency on golang
  resolves: #1223451

* Tue Jan 13 2015 jchaloup <jchaloup@redhat.com> - 0-0.4.git32d1910
- Bump to upstream 32d1910e654ead1308d9073d8ccdd42d6922ee39
  related: #1142399

* Fri Oct 10 2014 jchaloup <jchaloup@redhat.com> - 0-0.3.git9cad7da
- Add dependencies, replace motain/gocheck with check.v1
  related: #1142399

* Fri Sep 19 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.2.git9cad7da
- Resolves: rhbz#1142399 - initial package upload
- don't redefine gopath
- don't own dirs owned by golang
- preserve timestamps of copied files
- devel package buildrequires golang
- noarch
- correct package name format

* Mon Sep 15 2014 Eric Paris <eparis@redhat.com - 0.0.0-0.1.git9cad7da
- Bump to upstream 9cad7da945e699385c1a3e115aa255211921c9bb

